#include "ShallowPointer.h"


template <class T>
ShallowPointer<T>::ShallowPointer(T *pData)
	: pPointer(pData)
{
}

template <class T>
ShallowPointer<T>::ShallowPointer(const ShallowPointer &rhs)
{
	pPointer = rhs.pPointer ;   // Shallow Copy
}


template <class T>
ShallowPointer<T>::~ShallowPointer()
{
	pPointer = 0 ;              // Shallow Delete
}



template <class T>
T *const ShallowPointer<T>::GetPointer() const
{
	return pPointer ;
}

template <class T>
T *const ShallowPointer<T>::operator ->() const
{
	return GetPointer() ;
}

template <class T>
T & ShallowPointer<T>::operator *() const
{
	return *GetPointer() ;
}

template <class T>
int ShallowPointer<T>::operator <(const ShallowPointer &rhs)
{
      	return GetPointer()->operator<(*rhs.GetPointer()) ;
}

template <class T>
int ShallowPointer<T>::operator ==(const ShallowPointer &rhs)
{
	return GetPointer()->operator==(*rhs.GetPointer()) ;
}

